#!/usr/bin/speedy -- -g

# Dumps the messages in the current final delivery queue, as well as the number
# of messages that have been recently processed
# 
# Japheth Cleaver <cleaver@redwire.net>


BEGIN {
   our $yearmon;
   require '/etc/vpopmail/fd-common.pl';
};


INIT {

  CreateDBH();
  $|=1;
  $\="\n";		# output record separator (end of print statements)

  # Prepare statements now so that they're ready to go when scripts call them
    our $getTransferCount = $QBH->prepare("SELECT COUNT(*) FROM fd_recent_$yearmon");

  #  Use $retrieveCurQuery->execute();
    our $retrieveCurQuery = $QBH->prepare("SELECT id,del_dt,size,del_by,CONCAT(pw_name,'\@',pw_domain),del_from FROM fd_queue_$yearmon ORDER BY id");

};


$getTransferCount->execute() or die "Can't execute getTransferCount: $DBI::errstr";
print 'Recently processed messages: ', ($getTransferCount->fetchrow_array)[0] if $getTransferCount->rows();


$retrieveCurQuery->execute() or die "Can't execute retrieveCurQuery: $DBI::errstr\n";
print 'id	Received At		Size	Server		Email				Sender';

{ 

 local $, = '	';			# output field separator for print statement
 while (my @ref = $retrieveCurQuery->fetchrow_array) {
	$ref[3] =~ s/^([\w-]+\.[\w-]+).*$/$1/o;		# strip domain from procservers
	$ref[4] = sprintf '%-24s', $ref[4];		# only 1st 24 chars of email
	print @ref;
 };

};
