%define vHome		  %{_sysconfdir}/vpopmail
%define vpopmailVar	  %{_localstatedir}/vpopmail
%define vpopmailLog	  %{_localstatedir}/log/vpopmail
%define vpopmailSupervise %{_sysconfdir}/vpopmail/supervise
%define tcpserverDir	  %{_sysconfdir}/tcprules.d

%define domainsName	  domains
%define domainsDir	  %{vpopmailVar}/%{domainsName}

%define qmailHome	  %{_sysconfdir}/qmail
%define qmailNewu	  %{_sbindir}/qmail-newu
%define qmailNewmrh	  %{_sbindir}/qmail-newmrh
%define qmailInject	  %{_sbindir}/qmail-inject

%define	vpopmailUID	  89
%define	vpopmailGID	  89

%define realVpopmailVers  5.4.26d

Name: vpopmail
Version: 5.4.26
Release: 8.2%{?dist}
Summary: a virtual domain email account management package for qmail

Group: System Environment/Daemons
License: GPL
URL: http://www.inter7.com/?page=vpopmail
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)

BuildRequires: automake, autoconf, dietlibc, MySQL-devel
Requires(pre): qmail, daemontools, clamav, /usr/bin/mysql
Requires(post): /usr/bin/mysql
Requires(pre): %{name}-core = %{version}-%{release}
Provides: popserver, checkpassword
Requires: gawk, /usr/bin/watch

#Source0: http://us.dl.sourceforge.net/sourceforge/vpopmail/%{name}-%{version}.tar.gz
Source0: http://us.dl.sourceforge.net/sourceforge/vpopmail/%{name}-%{realVpopmailVers}.tar.gz
Source1: vpopmail.UPGRADE-5.4.23.sql

Source2:  vpopmail.vpopmail.mysql
Source3:  vpopmail.quotawarn.msg
Source4:  vpopmail.over-quota.msg
Source5:  vpopmail.vlistemails
Source8:  vpopmail.vdeldomain-safe
Source15: vpopmail.vchkpassd
Source16: vpopmail.vchkpassd.xinetd
Source32: vpopmail.vpoppassd
Source33: vpopmail.vpoppassd.run
Source37: vpopmail.vpoppassd.log.run
Source23: vpopmail.vusersize
Source35: vpopmail.vpopmaild.run
Source36: vpopmail.vpopmaild.log.run
Source30: vpopmail-fd.fd.mysql
Source6:  vpopmail-fd.vdelivermail
Source7:  vpopmail-fd.vrecordmail
Source9:  vpopmail-fd.vprocessmail
Source10: vpopmail-fd.fd-common.pl
Source11: vpopmail-fd.vtransferqueue
Source20: vpopmail-fd.dspam-parse.sh
Source19: vpopmail-fd.vmsgdelqueue
Source17: vpopmail-fd.vmsginfo
Source18: vpopmail-fd.vmsgreset
Source31: vpopmail-fd.fd-qstat
Source24: vpopmail-fd.vshowqueue.pl
Source22: vpopmail-fd.virus-replacement.msg
Source12: vpopmail-fd.fd-additions.sql
Source25: vpopmail-fd.vprocessmail.run
Source26: vpopmail-fd.vprocessmail.log.run
Source13: vpopmail-fd.vtransferqueue.run
Source14: vpopmail-fd.vtransferqueue.log.run
Source27: vpopmail-fd.vrcptcheck-real
Source28: vpopmail-fd.vrcptcheck.c
Source29: vpopmail-fd.vuserdir
Source34: vpopmail-fd.vwhitelist
Source101: vpopmail-fd.vrecentspam
Source102: vpopmail-fd.heloparse
Source103: vpopmail-fd.spfreport
Source104: vpopmail-fd.vchangesqlprefs

Source39: vpopmail.mysqlparse
Source40: vpopmail-cluster.local.cf-sqladditions
Source41: vpopmail-cluster.add_sa_awl.sql
Source42: vpopmail-fd.spamassassin-true_persistent_awl_sql.patch
Source43: vpopmail-fd.sysconfig
Source44: vpopmail-cluster.slave-start.sh
Source45: vpopmail-cluster.slave-stop.sh
Source46: vpopmail-cluster.slave-restart.sh
Source47: vpopmail-cluster.slave-update.sh
Source48: vpopmail-cluster.slave-maintenance.sh
Source49: vpopmail-cluster.master-update.sh
Source50: vpopmail-cluster.master-maintenance.sh
Source51: vpopmail-cluster.master-clustermaint-cleanup.sh
Source52: vpopmail-cluster.qmail-scrub
Source53: vpopmail-cluster.cluster-updatesarules.sh

# Enable our Final Delivery mechanism in vdelivermail
Patch0: vpopmail-fd.fd_capable_v2.patch

# Instead of vpopmail's home directory, use standard FHS locations:
# bindir, localstatedir, and sysconfdir for files (patches configure.in and code)
Patch1: vpopmail.use-std-locations.5.4.19.patch

# Modify makefile to deal with our above changes (patches Makefile.am)
Patch2: vpopmail.use-std-locations-makefile.patch

# Documentation changes for patches 1 and 2
Patch3: vpopmail.use-std-locations-documentation.patch


# Make vpopmail's configure rpmbuild-friendly
Patch4: vpopmail.no-root-needed.patch

# Don't verify that the qmail binaries are actually installed
# at configure time
Patch5: vpopmail.configure-no-qmail-needed.patch

# Same goes for tcpserver/tcprules
Patch6: vpopmail.configure-no-tcprules-needed.patch

# Look in /usr/{s}bin before /usr/local or {qmailHome}/bin when finding
# tcprules and qmail binaries
Patch7: vpopmail.configure-search-paths.patch

# Replace /bin/sh with /bin/ash for efficiency
Patch8: vpopmail.ash.5.4.19.patch

# Remove catchall detection - segfaults with mysql and vdeluser
Patch9: vpopmail-5.4.19.no-iscatchall-detect.patch 

# No legacy argument in vdelivermail call required
Patch10: vpopmail.nolegacyargsrequired.patch

# Ensure that all checks for libs are compatible with x86_64 (/usr/lib64)
Patch11: vpopmail.x86_64libs.patch

# Why are mysql libs being checked using the same variable as libdir?
Patch12: vpopmail.sanemysqllibs.patch

# Parse and check for X-Priority headers
Patch20: vpopmail.xpriority.patch
Patch21: vpopmail.xpriority.config.patch


#################################################
%description
Vpopmail is a set of programs for creating and managing
multiple virtual domains on a qmail server.

It is geared toward ease of use for system administrators as well 
as security and efficency. With the associated command line programs,
system administrators never need touch any of the underlying qmail files 
and processes. All details are automatically handled. 



#######################################################################
%package core
Group: Development/Libraries
Summary: Vpopmail users and shared libraries
Requires(pre): clamav

%description core
This package contains the core vpopmail library and the vpopmail user 
accounts. You'll need to install before you install any other vpopmail 
packages.


#######################################################################
%package devel
Group: Development/Libraries
Summary: Vpopmail development header files and libraries
Requires: %{name}-core = %{version}-%{release}


%description devel
This package contains the development header files and libraries
necessary to develope your own clamav based applications.



#######################################################################
%package vpoppassd
Group: System Environment/Daemons
Summary: a poppassd daemon for vpopmail
Requires: vpopmail = %{version}-%{release}, qmail-pop3d, words
Requires(pre): daemontools
Requires(post): daemontools
Obsoletes: vpopmail-vchkpassd
Provides: poppassd, qmail-poppassd, qmail-vpoppassd


%description vpoppassd
A poppassd utility (port 106) for use with a webmail or other mail 
client (eg, Eudora) that would like to be able to change the password
on a vpopmail account remotely.

Runs via tcpserver and requires qmail-popup from qmail-pop3d



#######################################################################
%package daemon
Group: System Environment/Daemons
Summary: a daemon for controlling vpopmail configuration
Requires: vpopmail = %{version}-%{release}
Requires(pre): daemontools
Requires(post): daemontools
Provides: vpopmaild, vpopmail-server


%description daemon
Vpopmaild is a local TCP daemon used to make changes to the vpopmail 
configuration over a socket. It is used (or will be eventually) by 
projects like qmailadmin and vqadmin.



#######################################################################
%package finaldelivery
Group: System Environment/Daemons
Summary: an asynchronous delivery framework for local user mail scanning
Requires: vpopmail = %{version}-%{release}, ripmime, gocr, perl-CGI-SpeedyCGI
Requires(pre): vpopmail = %{version}-%{release}, daemontools, simscan
Requires(post): vpopmail = %{version}-%{release}, daemontools


%description finaldelivery
Finaldelivery is a framework for processing mail asynchronously that is
delivered to local users (NOT including mail that is forwarded on from
the server). Only mail that is "finally delivered" locally is processed.

The FINALDELIVERY environment variable is set in %{_sbindir}/vdelivermail
which causes vdelivermail to run %{_sbindir}/vrecordmail when delivering
into a Maildir. Vrecordmail makes a note of this and exits; if successful,
the message is left in Maildir/tmp/ for later processing.

Another program, vprocessmail, runs asynchronously (via supervise) to 
read "pending messages" from the queue created by vrecordmail and 
performs scanning on them according to user and domain preferences. 

Once the message is re-written (if needed), it is moved to Maildir/new 
(potentially of whatever IMAP folder it is being moved to) and its 
disposition is noted in the database.



#######################################################################
%package cluster
Group: System Environment/Daemons
Summary: files for managing a qmail/vpopmail server cluster
Requires: vpopmail = %{version}-%{release}, vpopmail-finaldelivery = %{version}-%{release}, qmail, qmail-smtpd
Requires: daemontools, ucspi-tcp
Requires: qmailmrtg7, qmailadmin, qmail-autorespond

%description cluster
Contains management scripts that assist in running a cluster of qmail/
vpopmail servers, including propagation of configurations, update and
restart scripts, and other anaylsis tools.


%prep
%setup -q
%patch0
%patch1
%patch2
%patch3
%patch4
%patch5
%patch6
%patch7
%patch8
%patch9
%patch10
%patch11
%patch12

%patch20
%patch21

rm -fR autom4te.cache
autoreconf

# Manually configure user/group ids and the vpopmail home directory
  echo %{vpopmailUID}	> vpopmail.uid
  echo %{vpopmailGID}	> vpopmail.gid
  echo %{vHome}		> vpopmail.dir


%build
export LDFLAGS="-lpthread -ldl"

%configure \
  --bindir=%{_sbindir} \
  --sysconfdir=%{_sysconfdir}/%{name} \
  --localstatedir=%{_localstatedir}/%{name} \
  --datadir=%{_datadir}/%{name} \
  --includedir=%{_includedir}/%{name} \
  --enable-non-root-build \
  --enable-qmaildir=%{qmailHome} \
  --enable-qmail-newu=%{qmailNewu} \
  --enable-qmail-inject=%{qmailInject} \
  --enable-qmail-newmrh=%{qmailNewmrh} \
  --enable-tcprules-prog=%{_sbindir}/tcprules \
  --enable-vpopuser=vpopmail \
  --enable-vpopgroup=vchkpw \
  --enable-roaming-users \
  --disable-tcpserver-file \
  --disable-rebuild-tcpserver-file \
  --enable-relay-clear-minutes=180 \
  --enable-learn-passwords \
  --enable-md5-passwords \
  --disable-file-locking \
  --disable-file-sync \
  --enable-make-seekable \
  --enable-clear-passwd \
  --enable-users-big-dir \
  --disable-sqwebmail-pass \
  --enable-qmail-ext \
  --enable-ip-alias-domains \
  --enable-domains-dir=%{domainsName} \
  --enable-auth-module=mysql \
  --disable-passwd \
  --enable-logging=p \
  --enable-log-name=vpopmail \
  --enable-auth-logging=y \
  --disable-sql-logging \
  --enable-mysql-limits \
  --enable-mysql-replication \
  --enable-valias \
  --enable-many-domains

make %{?_smp_mflags}
#make -d

# This is our setuid vpopmail c-wrapper around vrcptcheck-real,
# required so that the program run by qmail-smtpd can check for
# the existance of a .qmail- file inside a virtual domain's
# directory. vrcptcheck-real is responsible for ensuring that 
# nothing inappropropriate comes in on the command line; vrcptcheck
# does not read any arguments in.
  diet gcc -Os -o vrcptcheck.exe %{SOURCE28}


%install
rm -fR %{buildroot}

# Create our directories manually first...
 install -d %{buildroot}%{_bindir}
 install -d %{buildroot}%{_sbindir}
 install -d %{buildroot}%{_libdir}
 install -d %{buildroot}%{_includedir}/%{name}
 install -d %{buildroot}%{_sysconfdir}/%{name}
 install -d %{buildroot}%{_localstatedir}/%{name}

 install -d %{buildroot}%{vHome}
 install -d %{buildroot}%{domainsDir}
 install -d %{buildroot}%{vpopmailLog}
 install -d %{buildroot}%{tcpserverDir}
 install -d %{buildroot}%{vpopmailSupervise}
 install -d %{buildroot}%{_sysconfdir}/sysconfig

 make install DESTDIR=%{buildroot}


# Remove HTML documentation, we'll add it later from the BUILD tree
# using the docdir macro
 rm -fR %{buildroot}%{vHome}/doc/

# Move stuff out of etc and into our vHome root...
 mv -f %{buildroot}%{vHome}/etc/* %{buildroot}%{vHome}/
 rmdir %{buildroot}%{vHome}/etc

# Add our scripts to supervise...
#	vpopmaild = vpopmail config daemon
#	vpoppassd = vpopmail poppassd daemon
#	vprocessmail = asynchronous finaldelivery processor
#	vtransferqueue = moves "recent" msgs into the mail database
 install -m 755 -d %{buildroot}%{vpopmailSupervise}/vpopmaild/log
 install -m 755 -d %{buildroot}%{vpopmailSupervise}/vpoppassd/log
 install -m 755 -d %{buildroot}%{vpopmailSupervise}/vprocessmail/log
 install -m 755 -d %{buildroot}%{vpopmailSupervise}/vtransferqueue/log
 install -m 755 %{SOURCE35} %{buildroot}%{vpopmailSupervise}/vpopmaild/run
 install -m 755 %{SOURCE36} %{buildroot}%{vpopmailSupervise}/vpopmaild/log/run
 install -m 755 %{SOURCE33} %{buildroot}%{vpopmailSupervise}/vpoppassd/run
 install -m 755 %{SOURCE37} %{buildroot}%{vpopmailSupervise}/vpoppassd/log/run
 install -m 755 %{SOURCE25} %{buildroot}%{vpopmailSupervise}/vprocessmail/run
 install -m 755 %{SOURCE26} %{buildroot}%{vpopmailSupervise}/vprocessmail/log/run
 install -m 755 %{SOURCE13} %{buildroot}%{vpopmailSupervise}/vtransferqueue/run
 install -m 755 %{SOURCE14} %{buildroot}%{vpopmailSupervise}/vtransferqueue/log/run

# Flesh out our log directories
 install -m 755 -d %{buildroot}%{vpopmailLog}/{vpopmaild,vpoppassd,vprocessmail,vtransferqueue}

# And tcprules files for our network accessible daemons
  echo ":allow"		>  %{buildroot}%{tcpserverDir}/vpoppassd
  echo "127.:allow"	>  %{buildroot}%{tcpserverDir}/vpopmaild
  echo ":deny"		>> %{buildroot}%{tcpserverDir}/vpopmaild


# Replace some distribution directories in vHome with symlinks
  pushd %{buildroot}%{vHome}
     rmdir bin lib include %{domainsName}
     ln -s %{vHome} etc
     ln -s %{_sbindir} bin
     ln -s %{_libdir} lib
     ln -s %{_includedir}/%{name} include
     ln -s %{domainsDir} %{domainsName}
  popd


# Install default mysql and error message files
  install -m 440 %{SOURCE2} %{buildroot}%{vHome}/vpopmail.mysql
  install -m 440 %{SOURCE39} %{buildroot}%{vHome}/mysqlparse
  install -m 644 %{SOURCE3} %{buildroot}%{_sysconfdir}/%{name}/quotawarn.msg
  install -m 644 %{SOURCE4} %{buildroot}%{_sysconfdir}/%{name}/over-quota.msg

# Various convenience scripts for command line use
  install -m 755 %{SOURCE5}  %{buildroot}%{_sbindir}/vlistusers
  install -m 755 %{SOURCE23} %{buildroot}%{_sbindir}/vusersize
  install -m 755 %{SOURCE29} %{buildroot}%{_sbindir}/vuserdir
  install -m 755 %{SOURCE34} %{buildroot}%{_sbindir}/vwhitelist

# Our vpoppassd script (a port 106 poppassd daemon)
  install -m 755 %{SOURCE32} %{buildroot}%{_sbindir}/vpoppassd

# Our interface to the $RCPTCHECK patch for qmail
  install -m 6755 vrcptcheck.exe %{buildroot}%{_sbindir}/vrcptcheck
  install -m 755 %{SOURCE27} %{buildroot}%{_sbindir}/vrcptcheck-real

# Symlink vchangepw to bin, for access by non-root folks
  %{__ln_s} %{_sbindir}/vchangepw %{buildroot}%{_bindir}/vchangepw


# Replace vdeldomain with "safe" version -- we don't delete the default domain
  mv -f %{buildroot}%{_sbindir}/vdeldomain %{buildroot}%{_sbindir}/vdeldomain-real
  install -m 755 %{SOURCE8} %{buildroot}%{_sbindir}/vdeldomain


# Move the real vdelivermail out of the way, it will get called by our
# final delivery shim
  install -m 755 %{buildroot}%{_sbindir}/vdelivermail %{buildroot}%{_sbindir}/vdelivermail-real
  install -m 755 %{SOURCE6}  %{buildroot}%{_sbindir}/vdelivermail

############################
### Final Delivery stuff...
############################

# Config files...
  install -m 644 %{SOURCE43} %{buildroot}%{_sysconfdir}/sysconfig/vpopmail
  install -m 644 %{SOURCE10} %{buildroot}%{vHome}/fd-common.pl
  install -m 444 %{SOURCE30} %{buildroot}%{vHome}/fd.mysql.DIST
  install -m 644 %{SOURCE22} %{buildroot}%{vHome}/virus-replacement.msg

# "Binaries"
  install -m 755 %{SOURCE7}  %{buildroot}%{_sbindir}/vrecordmail
  install -m 755 %{SOURCE9}  %{buildroot}%{_sbindir}/vprocessmail
  install -m 755 %{SOURCE11} %{buildroot}%{_sbindir}/vtransferqueue
  install -m 755 %{SOURCE20} %{buildroot}%{_sbindir}/dspam-parse.sh

# Convenience scripts
  install -m 755 %{SOURCE19} %{buildroot}%{_sbindir}/vmsgdelqueue
  install -m 755 %{SOURCE17} %{buildroot}%{_sbindir}/vmsginfo
  install -m 755 %{SOURCE18} %{buildroot}%{_sbindir}/vmsgreset
  install -m 755 %{SOURCE101} %{buildroot}%{_sbindir}/vrecentspam
  install -m 755 %{SOURCE102} %{buildroot}%{_sbindir}/heloparse
  install -m 755 %{SOURCE103} %{buildroot}%{_sbindir}/spfreport
  install -m 755 %{SOURCE104} %{buildroot}%{_sbindir}/vchangesqlprefs
  install -m 755 %{SOURCE24} %{buildroot}%{_sbindir}/vshowqueue
  install -m 755 %{SOURCE31} %{buildroot}%{_sbindir}/fd-qstat

# Cluster scripts
  install -m 755 %{SOURCE44} %{buildroot}%{_sbindir}/cluster-start.sh
  install -m 755 %{SOURCE45} %{buildroot}%{_sbindir}/cluster-stop.sh
  install -m 755 %{SOURCE46} %{buildroot}%{_sbindir}/cluster-restart.sh
  install -m 755 %{SOURCE47} %{buildroot}%{_sbindir}/cluster-update.sh
  install -m 755 %{SOURCE48} %{buildroot}%{_sbindir}/cluster-maintenance.sh
  install -m 755 %{SOURCE49} %{buildroot}%{_sbindir}/master-update.sh
  install -m 755 %{SOURCE50} %{buildroot}%{_sbindir}/master-maintenance.sh
  install -m 755 %{SOURCE51} %{buildroot}%{_sbindir}/master-clustermaint-cleanup.sh
  install -m 755 %{SOURCE52} %{buildroot}%{_sbindir}/qmail-scrub
  install -m 755 %{SOURCE53} %{buildroot}%{_sbindir}/cluster-updatesarules.sh


# Documentation, SQL scripts, and other accessories in doc
  install -m 644 %{SOURCE1} UPGRADE.sql
  install -m 644 %{SOURCE12} fd-additions.sql
  install -m 644 %{SOURCE40} spamassassin-sql_local.cf
  install -m 644 %{SOURCE41} spamassassin-tables.sql
  install -m 644 %{SOURCE42} spamassassin-true_persistent_awl_sql.patch


#########################################################################
#########################################################################
#			SCRIPTLETS					#
#########################################################################
#########################################################################

%pre core
if [ "$1" -eq 1 ]; then

   /usr/sbin/groupadd -g %{vpopmailGID} -o vchkpw || :
   /usr/sbin/useradd -c "vpopmail" -u %{vpopmailUID} -o -g vchkpw \
	-M -d "%{vHome}" vpopmail || :
   /usr/sbin/usermod -G clamav,daemon,qmail vpopmail || :

else

   # Ensure that groups are set properly
   /usr/sbin/usermod -G clamav,daemon,qmail vpopmail || :

fi


%pre finaldelivery
# Check that mysql is working and vpopmail DB has been created
  . %{vHome}/mysqlparse

  echo "SELECT COUNT(*) FROM vpopmail" | $vpopmailWRITE >/dev/null
  if [ "$?" -ne 0 ]; then
      echo "Vpopmail must be fully set up in %{vHome}/vpopmail.mysql"
      echo "before attempting to install vpopmail-finaldelivery"
      exit 1
  fi


#######################################################################

%post core -p /sbin/ldconfig

%post

  # Allow qmail-smtpd and qmail-send (and programs run by those daemons -- 
  # meaning programs run by those users) to read our vchkpw group files...
  /usr/sbin/usermod -G vchkpw qmaild		|| :
  /usr/sbin/usermod -G vchkpw qmails		|| :

  # Allow vpopmail user to edit /etc/qmail/control/ and /etc/qmail/users/
  if [ -d "%{qmailHome}" ]; then
	chown -R vpopmail:qmail %{qmailHome}/control	|| :
	chown -R vpopmail:qmail %{qmailHome}/users	|| :
  fi

  # Only do this on installs, not upgrades
  if [ "$1" -eq 1 ]; then

    if [ ! -f "%{vHome}/defaultdomain" ] ; then
	# Add default domain if it doesn't exist
	FQDN=`uname -n`
	DOMAINNAME=`echo "$FQDN" | %{__perl} -ne "s/.*\.([a-z0-9-]+\.[a-z]+)$/\1/i;" -e "print lc"`

	echo " *** Setting default domain to $DOMAINNAME (edit at %{vHome}/defaultdomain)"
	echo "$DOMAINNAME" > %{vHome}/defaultdomain
    fi

    if [ ! -f %{vHome}/install.pass ]; then
      # Create a random vpopmail password
      THEPASS=`perl -e "print map {(0 .. 9,'A'..'Z','a'..'z','.','_','-')[ int(rand 65) ]} (1..16)"`
      touch %{vHome}/install.pass		|| :
      chmod 400 %{vHome}/install.pass
      cat >%{vHome}/install.pass <<-HERE
	$THEPASS
	HERE
    fi
    export THEPASS=`cat %{vHome}/install.pass`

    # This has no effect if the vpopmail.mysql file already has a custom password in it...
    %{__perl} -pi -e "s/INSTALLEDVPOPMAILPASSWORD/$THEPASS/" %{vHome}/vpopmail.mysql %{vHome}/fd.mysql.DIST || :

    # Install MySQL database.
    MYSQLPR=/usr/bin/mysql

    if [ ! -d /var/lib/mysql/vpopmail ] ; then

      # No database seems to be present...

      echo "* Edit %{vHome}/vpopmail.mysql with details for your MySQL server"
      echo "* Read %{_defaultdocdir}/%{name}-%{version}/README.mysql for more info."

      # Check for MySQL running
      if [ -f /var/lock/subsys/mysql ]; then

	# MySQL is on!
	echo "CREATE DATABASE IF NOT EXISTS vpopmail" | "$MYSQLPR" >/dev/null
	if [ "$?" -eq 0 ] ; then
	   # No password needed...
	   echo "GRANT ALL PRIVILEGES ON vpopmail.* TO vpopmail@localhost IDENTIFIED BY '$THEPASS'" | "$MYSQLPR"

	else
	   echo " *** Creating a local MySQL database for vpopmail ***"
	   echo " --- Log in as root if needed ..."
	   echo "CREATE DATABASE IF NOT EXISTS vpopmail; GRANT ALL PRIVILEGES ON vpopmail.* TO vpopmail@localhost IDENTIFIED BY '$THEPASS'" | "$MYSQLPR"

	fi

	%{_sbindir}/vadddomain -r notareal.example.net >/dev/null	|| :
	%{_sbindir}/vdeldomain-real notareal.example.net >/dev/null	|| :



      else

	echo ""
	echo "=== IMPORTANT ================================================"
	echo ""
	echo "* You must create the vpopmail MySQL database before this will work"
	echo "* Edit %{vHome}/vpopmail.mysql with details for your MySQL server"
	echo "* Read %{_defaultdocdir}/%{name}-%{version}/README.mysql for more info"
	echo "* To activate the default user and password, type: "
	echo ""
	echo "  echo \"GRANT ALL PRIVILEGES ON vpopmail.* TO vpopmail@localhost IDENTIFIED BY '$THEPASS'\" | $MYSQLPR"
	echo ""
	echo "=============================================================="

      fi # end mysql not running
    fi # end vpopmaildb not present
  elif [ "$1" -ge 2 ]; then

    # Get SQL data, and check with a dummy statement that the server is up
    . %{vHome}/mysqlparse

    # Check for connectivity
    echo | $vpopmailWRITE

    if [ "$?" -eq 0 ]; then
	$vpopmailWRITE -f < %{_defaultdocdir}/%{name}-%{version}/UPGRADE.sql >/dev/null 
    else
    	echo "*** You may need to run SQL commands in %{_defaultdocdir}/%{name}-%{version}/UPGRADE.sql ***"
    fi

  fi # end if installing


#######################################################################

%post finaldelivery

  # Install the final delivery database tweaks
  if [ "$1" -eq 1 ]; then

    # Get SQL data, and check with a dummy statement that the server is up
    . %{vHome}/mysqlparse

    # Check for connectivity
    echo | $vpopmailWRITE

    if [ "$?" -eq 0 ]; then
      $vpopmailWRITE -f < %{_defaultdocdir}/%{name}-finaldelivery-%{version}/fd-additions.sql >/dev/null

    else
      echo ""
      echo "=== IMPORTANT ================================================"
      echo ""
      echo "* Before you can run the finaldelivery processes, you MUST run"
      echo "* the following SQL script:"
      echo ""
      echo "  %{_defaultdocdir}/%{name}-finaldelivery-%{version}/fd-additions.sql"
      echo ""
      echo "=============================================================="

    fi

    # Ensure Mail::RFC822::Address and Crypt::PasswdMD5 is installed!
    echo " *** Be sure to install the following perl modules if needed:"
    echo "   Mail::RFC822::Address Crypt::PasswdMD5"

    /sbin/service svscan add "%{vpopmailSupervise}/vprocessmail"	>/dev/null || :
    /sbin/service svscan add "%{vpopmailSupervise}/vtransferqueue"	>/dev/null || :

    # If we're running simscan, we'll need clamdscan to run as root. Vprocessmail
    # only needs vpopmail user access, but qmail-smtpd which runs as qmaild is
    # what runs simscan...
    [ -f "%{_sysconfdir}/clamd.conf" ] && \
	%{__perl} -pi -e "s/^#?User \w+/User root/" %{_sysconfdir}/clamd.conf	|| :
    /sbin/service clamd condrestart >/dev/null 2>&1 				|| :

  fi # end initial install



#######################################################################
#######################################################################
%preun daemon
if [ "$1" -eq 0 ]; then
   /sbin/service svscan del vpopmaild			>/dev/null || :
fi


%preun vpoppassd
if [ "$1" -eq 0 ]; then
   /sbin/service svscan del vpoppassd			>/dev/null || :
fi


%preun finaldelivery
if [ "$1" -eq 0 ]; then
   /sbin/service svscan del vprocessmail		>/dev/null || :
   /sbin/service svscan del vtransferqueue		>/dev/null || :
fi



#######################################################################
%postun core
if [ "$1" -eq 0 ]; then
    /usr/sbin/userdel vpopmail				|| :
    /usr/sbin/groupdel vchkpw				|| :
fi
/sbin/ldconfig


%postun daemon
if [ "$1" -eq 1 ]; then
    /sbin/service svscan condrestart vpopmaild		>/dev/null || :
fi


%postun vpoppassd
if [ "$1" -eq 1 ]; then
    /sbin/service svscan condrestart vpoppassd		>/dev/null || :
fi


%postun finaldelivery
if [ "$1" -eq 1 ]; then
    /sbin/service svscan condrestart vprocessmail	>/dev/null || :
    /sbin/service svscan condrestart vtransferqueue	>/dev/null || :
fi


#######################################################################
#######################################################################
%clean
rm -fR %{buildroot}


%files
%defattr(-,root,root)
%doc AUTHORS COPYING FAQ INSTALL README* UPGRADE*
%docdir contrib
%doc contrib/*
%docdir doc
%doc doc/*

%attr(6755,vpopmail,vchkpw) %{_sbindir}/clearopensmtp
%attr(6755,vpopmail,vchkpw) %{_sbindir}/vchkpw
%{_bindir}/vchangepw
%{_sbindir}/dotqmail2valias
%{_sbindir}/vaddaliasdomain
%{_sbindir}/vadddomain
%{_sbindir}/vadduser
%{_sbindir}/valias
%{_sbindir}/vchangepw
%{_sbindir}/vchangesqlprefs
%{_sbindir}/vconvert
%{_sbindir}/vdeldomain
%{_sbindir}/vdeldomain-real
%{_sbindir}/vdelivermail
%{_sbindir}/vdelivermail-real
%{_sbindir}/vdeloldusers
%{_sbindir}/vdeluser
%{_sbindir}/vdominfo
%{_sbindir}/vipmap
%{_sbindir}/vkill
%{_sbindir}/vlist
%{_sbindir}/vlistusers
%{_sbindir}/vmkpasswd
%{_sbindir}/vmoddomlimits
%{_sbindir}/vmoduser
%attr(750,vpopmail,vchkpw) %{_sbindir}/vpasswd
%{_sbindir}/vpopbull
%{_sbindir}/vsetuserquota
%{_sbindir}/vuserinfo
%{_sbindir}/vusersize

%attr(755,vpopmail,vchkpw) %{vHome}/bin
%attr(755,vpopmail,vchkpw) %{vHome}/%{domainsName}
%attr(644,vpopmail,vchkpw) %config(noreplace) %{vHome}/vlimits.default
%attr(440,vpopmail,vchkpw) %config(noreplace) %{vHome}/vpopmail.mysql
%attr(440,vpopmail,vchkpw) %{vHome}/mysqlparse
%attr(755,vpopmail,vchkpw) %{vpopmailVar}

%dir %{vpopmailSupervise}
%attr(775,vpopmail,vchkpw) %dir %{vpopmailLog}

%attr(644,vpopmail,vchkpw) %config(noreplace) %{_sysconfdir}/%{name}/quotawarn.msg
%attr(644,vpopmail,vchkpw) %config(noreplace) %{_sysconfdir}/%{name}/over-quota.msg




#######################################################################
%files core
%attr(755,vpopmail,vchkpw) %dir %{vHome}
%attr(755,vpopmail,vchkpw) %{vHome}/etc
%attr(755,vpopmail,vchkpw) %{vHome}/lib
%attr(-,root,root) %{_libdir}/libvpopmail.a


#######################################################################
%files daemon
%attr(-,root,root) %config(noreplace) %{vpopmailSupervise}/vpopmaild
%attr(-,root,root) %config(noreplace) %{tcpserverDir}/vpopmaild
%attr(755,vpopmail,vchkpw) %{vpopmailLog}/vpopmaild
%attr(-,root,root) %{_sbindir}/vpopmaild


#######################################################################
%files devel
%attr(-,root,root) %{vHome}/include
%attr(-,root,root) %{vHome}/inc_deps
%attr(-,root,root) %{vHome}/lib_deps
%attr(-,root,root) %{_includedir}/%{name}


#######################################################################
%files vpoppassd
%attr(-,root,root) %config(noreplace) %{vpopmailSupervise}/vpoppassd
%attr(-,root,root) %config(noreplace) %{tcpserverDir}/vpoppassd
%attr(755,vpopmail,vchkpw) %{vpopmailLog}/vpoppassd
%attr(-,root,root) %{_sbindir}/vpoppassd


#######################################################################
%files finaldelivery
%defattr(-,root,root)
%doc fd-additions.sql spamassassin-sql_local.cf 
%doc spamassassin-tables.sql spamassassin-true_persistent_awl_sql.patch

%attr(644,vpopmail,vchkpw) %{vHome}/fd-common.pl
%attr(444,vpopmail,vchkpw) %config %{vHome}/fd.mysql.DIST
%attr(644,vpopmail,vchkpw) %config(noreplace) %{vHome}/virus-replacement.msg
%attr(644,vpopmail,vchkpw) %config(noreplace) %{_sysconfdir}/sysconfig/vpopmail

%attr(755,vpopmail,vchkpw) %{vpopmailLog}/vprocessmail
%attr(755,vpopmail,vchkpw) %{vpopmailLog}/vtransferqueue

%{_sbindir}/dspam-parse.sh
%{_sbindir}/fd-qstat
%{_sbindir}/heloparse
%{_sbindir}/spfreport
%{_sbindir}/vmsgdelqueue
%{_sbindir}/vmsginfo
%{_sbindir}/vmsgreset
%{_sbindir}/vprocessmail
%{_sbindir}/vrcptcheck-real
%{_sbindir}/vrecordmail
%{_sbindir}/vrecentspam
%{_sbindir}/vshowqueue
%{_sbindir}/vtransferqueue
%{_sbindir}/vuserdir
%{_sbindir}/vwhitelist
%attr(6755,vpopmail,vchkpw) %{_sbindir}/vrcptcheck

%config(noreplace) %{vpopmailSupervise}/vprocessmail
%config(noreplace) %{vpopmailSupervise}/vtransferqueue


#######################################################################
%files cluster
%defattr(-,root,root)
%{_sbindir}/qmail-scrub
%{_sbindir}/cluster-start.sh
%{_sbindir}/cluster-stop.sh
%{_sbindir}/cluster-restart.sh
%{_sbindir}/cluster-update.sh
%{_sbindir}/cluster-maintenance.sh
%{_sbindir}/master-update.sh
%{_sbindir}/master-maintenance.sh
%{_sbindir}/master-clustermaint-cleanup.sh
%{_sbindir}/cluster-updatesarules.sh


%changelog
* Mon Sep 30 2013 Japheth Cleaver <cleaver@terabithia.org> 5.4.26-8.2
- rebuild
- change BuildRequires from mysql-devel to MySQL-devel
- tighten patches
- update /bin/ash to /bin/dash

* Wed Jul 25 2012 Japheth Cleaver <cleaver@terabithia.org> 5.4.26-8.1
- add -lpthread -ldl  per http://forums.mysql.com/read.php?117,400127,400368#msg-400368
- remove obsolete cleaver-utils -- you can write sortlines yourself

* Thu Jun 05 2008 Japheth Cleaver <cleaver@redwire.net> 5.4.26-8
- ensure x86_64 libdir compliance (mysql and libvpopmail.a checks)

* Thu May 08 2008 Japheth Cleaver <cleaver@redwire.net> 5.4.26-7
- shell bug in mysqlparse was preventing vmsginfo/vmsgreset from working
- speed tweaks and a typo fix in vshowqueue

* Tue Mar 25 2008 Japheth Cleaver <cleaver@redwire.net> 5.4.26-6
- remove courier-imap from Requires for vpopmail-cluster scripts

* Mon Mar 17 2008 Japheth Cleaver <cleaver@redwire.net> 5.4.26-5
- spec: wrong source for vpoppasswd/log/run script

* Wed Mar 05 2008 Japheth Cleaver <cleaver@redwire.net> 5.4.26-4
- vrcptcheck/fd-common.pl was not reading hashes properly or checking
  badhelo/authsenderrequired data

* Fri Jan 18 2008 Japheth Cleaver <cleaver@redwire.net> 5.4.26-3
- vrecordmail was not setting the new priority DB value properly

* Wed Jan 9 2008 Japheth Cleaver <cleaver@redwire.net> 5.4.26-2
- rh9 bug: remove the autom4te cache before autoreconf

* Wed Dec 19 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.26-1
- update to 5.4.26
- vprocessmail: look for X-Originating-IP headers instead of 
  patched simscan
- more robust user creation in vpopmail-core


* Thu Oct 11 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.25-0
- update to 5.4.25


* Tue Oct 2 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.23-2
- modify how FINALDELIVERY is called to use environment variables
  keep existing method as well, but the next release will
  fork vrecordmail without arguments -- should be seamless
- add newline at end of vuserdir's output
- remove legacy initial dummy argument for vdelivermail


* Wed Sep 26 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.23-0
- update to 5.4.23
- break vpopmail/vchkpw user creation, libraries, and ~vpopmail
  home directory into vpopmail-core
- read /etc/sysconfig/vpopmail in prior to running vprocessmail
- don't munge our replacement vdelivermail script on install any more
  test for presence of vrecordmail to determine final delivery
- break mysql-parsing out from /etc/sysconfig/vpopmail so that
  we can use it during the initial vpopmail install
- auto apply SQL upgrades if possible
- require valid MySQL info prior to finaldelivery install
- revert to default vlimits.default file
- lots of scriptlet tweaks and fixes


* Tue Sep 11 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.21-0
- update to 5.4.21

* Wed Sep 5 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.20-0
- update to 5.4.20

* Fri Aug 31 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.19-2
- add cluster-updatesarules script
- replace vchkpassd with vpoppassd (poppassd 106 daemon)
- no longer requires xinetd, uses tcpserver and qmail-popup instead
- tighten security on /usr/sbin/vpasswd

* Thu Aug 23 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.19-1
- patch for vdeluser segfault

* Tue Aug 14 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.19-0
- update to 5.4.19a
- add vchangesqlprefs
- add vblacklist as alias of vwhitelist
- more cluster script updates
- add vpopmail user to -devel package as well
- add qmail-scrub

* Fri Mar 16 2007 Japheth Cleaver <cleaver@redwire.net> 5.4.18-0
- update to 5.4.18
- split headers into devel package
- reliability updates to all cluster scripts
- vmsginfo now checks fd_recent_ db as well
- vwhitelist handles domain_prefs files for all-domain whitelisting

* Wed Dec 20 2006 Japheth Cleaver <cleaver@redwire.net> 5.4.17-17
- misc spec cleanup to build with fc6
- skip check for tcprules' existance in configure.in
- add /usr/bin/mysql to Requires(pre/post)
- add courier-imap, courier-authlib to -cluster Requires

* Fri Nov 17 2006 Japheth Cleaver <cleaver@redwire.net> 5.4.17-15.1
- fix uninited 'eq' in fd-common.pl

* Mon Nov 13 2006 Japheth Cleaver <cleaver@redwire.net> 5.4.17-15
- really switch from sh to ash
- no longer BuildRequire qmail or ucspi-tcp (rejoice!)
- add BuildRequires mysql-devel
- typo when parsing domainHome in vprocessmail


* Wed Nov 1 2006 Japheth Cleaver <cleaver@redwire.net> 5.4.17-13
- vmsginfo: accept full msgid's on the command line
- vprocessmail: more efficient invocation of dspam-parse.sh
- vprocessmail: allow per-domain spamassassin prefs via 'domain_prefs'
  file in the domain's home directory
- fd-common.pl now reads vpopmail/defaultdomain on init
- vuserdir now assumes a bare username is of the default domain
- add spfreport - parse SPF results in smtpd*/current
- add awl DB connection abilities in fd-common.pl for future processing
- can do processing by size now instead of id, to take care of 
  shorter/quicker messages first if there's a backlog or during an attack
- add Requires: gocr package (prepare for integration of FuzzyOCR logic
  directly into vprocessmail)
- vpopmail-cluster script updates
- vrcptcheck shim now built with dietlibc. Every little bit helps.


* Thu Sep 28 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.17-12
- vrcptcheck: print SPF status on log lines after HELO
- vwhitelist: check for and remove '&' in alias lines
- fd-common.pl: bug in qmailListFile results
- fd-common.pl: clear hash before re-populating in qmailHashRefFile


* Thu Sep 21 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.17-10
- in vprocessmail, parse _VPOPMAILFD_MSGID_ in SA-rewritten
  mail and replace with the msgid -- for easier reporting.
- add simscanmk -g to cluster-maintenance
- more cluster script tweaks
- fd-common.pl now sets $ENV{'TMPDIR'} to the $scratchDir
- add heloparse script, add cleaver-utils as require (get it from this repo)
  for sortlines utility


* Thu Aug 10 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.17-9
- bugfixes in finaldelivery(Post)
- drop dspam as a finaldelivery(Requires)
- add Requires: vpopmail = %{version}-%{release} to all sub-packages


* Wed Aug 09 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.17-5
- when configured to only store the header of a message in the 
  archives (and not the full body), vprocessmail now stores the 
  original header instead of one potentially rewritten or replaced
  by SpamAssassin
- add vrecentspam utility
- minor tweaks to cluster scripts, cluster-maintenance now will 
  restart svscan as well if given svscan as an argument
- unexport some variables in /etc/sysconfig/vpopmail
- on new installs, the vpopmail mysql password is randomly generated


* Wed Aug 02 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.17-4
- add finish() to settings handle in fd-common.pl before disconnect
- decrease base sleep time in vprocessmail from 5s to 4s
- cluster no longer requires ezmlm or mess822


* Wed Aug 02 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.17-3
- vprocessmail was not resetting the SA conf back to defaults after
  processing the mail of someone who had a custom user_prefs file
- now log HELO value in vrcptcheck output
- allow vtransferqueue to read the proper YYYYMM from args
- add vmsgdelqueue
- break cluster scripts into separate package
- updates to cluster scripts, add master-maintenance.sh


* Mon Jul 17 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.17-1
- updated to 5.4.17
- add vwhitelist


* Mon Jun 12 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.16-6.1
- add checkpassword to provides


* Wed May 31 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.16-6
- sysconfig fix -- call uname -n if $HOSTNAME is blank because env
  has been cleared (eg, via cron)
- try to back out of the "current" message if vprocessmail is killed
  thereby preventing messages from being hung in the queue if we do
  it on a regular basis


* Thu May 25 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.16-5
- vlistemails bugfix
- vprocessmail: instead of the proc_id, use multiple of pid * attempt#
  when writing the X-Final-Delivery msgid header; allows for effective
  use of msgid value as a non-trivially-sequencable validator/verifier
- add 'badmailfromdomains' file to be read by vrcptcheck, like
  badmailfrom file, except a list of domains, one per line, to be 
  rejected
- a suitable badmailfromdomains file can be downloaded from
  http://www.sa-blacklist.stearns.org/sa-blacklist/sa-blacklist.current.at-domains
  but must be piped through "tr -d '@'" first


* Fri May 19 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.16-4
- fixes for robustness in vtransferqueue
- vshowqueue rewritten in speedy perl for persistency
- smarter use of freshclam in vprocessmail + bugfixes


* Fri May 12 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.16-3
- add cluster-update.sh and master-update.sh examples
- modify speedycgi settings on various scripts
- typo in vuserdir
- split DBs from 2 -> 3 (queue, recent, and storage)
- vprocessmail now moves messages from queue to recent
- add vtransferqueue - runs via supervise to move processed mail from
  "recent" to "storage"


* Tue May 09 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.16-2
- fix delivery to alternate maildirs in vprocessmail


* Mon May 08 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.16-1
- update to 5.4.16
- more efficient /etc/sysconfig/vpopmail structure
- bugfix for finaldelivery upgrade script
- add fd-qstat script a la qmail-qstat


* Sat May 06 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-13
- remove tail -f hack to get versions from freshclam


* Fri May 05 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-11
- vprocessmail can now delete messages per user prefs and records
  disposition properly (note: fd_mail schema has changed)
- autoreconf instead of running aclocal/autoconf/automake ourselves
- remove unnecessary config.h patching since we're using reautoconf
- use rpm defines for vpopmail's uid/gid
- PreReq -> Requires(pre)


* Wed May 03 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-7
- more cleanup
- bugfixes in vprocessmail/vrecordmail/fd-common.pl
- remove Config::Tiny dependency, read default config from hash
- move /etc/sysconfig/cluster to /etc/sysconfig/vpopmail
- add temporary cluster-{start|stop}.sh scripts
- update vmsginfo vmsgreset vshowqueue files


* Wed May 03 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-5
- print out SpamAssassin test results in verbose mode
- include sample local.cf file for SQL-based whitelist and bayes
- include patch for persistent awl handles in SpamAssassin
- remove doc and log directories from /etc/vpopmail
- symlinks are now absolute rather than relative


* Sun Apr 30 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-4
- bugfixes relating to changes in vrecordmail/vprocessmail


* Sun Apr 30 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-3
- add vpopmail.200603041811.patch for valias/qmailadmin
- vprocessmail: always allow spamassassin to rewrite
- add default local.cf file for spamassassin use.
- minor speedups in vrcptcheck-real and fd-common.pl
- major changes in vrecordmail/vprocessmail...
  -- split queue and storage tables for better performance

 
* Wed Apr 05 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-2
- Massive spec file cleanups
- vchkpw was in the wrong package, moved to main
- remove install -o user -g group from install scripts
- bugfix in vchkpassd (allow '-@_.' chars in passwords)


* Wed Mar 08 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-1
- Major patch tweaks, break them up by purpose and re-document
- Run aclocal and automake during prep, along with autoconf
- Remove explicit stripping of binaries, rpmbuild does this for us
- Move supervise dir to main package, since vpopmaild requires it
- change BINDIR to SBINDIR in vdelivermail writes


* Tue Feb 28 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.15-0
- Update to 5.4.15
- Rename patches to correlate with version-dependancy
- Add clamav to main package's Require, simscan to finaldelivery's
- vpopmail useradd command tweaks:
  * add clamav group
  * change shell from /bin/true to /sbin/nologin
- setuidgid and multilog are in /sbin/ now, not /usr/sbin/
- Move daemontools from finaldelivery to main package, since vpopmaild
  requres it
- vrcptcheck-real doesn't need to be 6755, only the C wrapper does
- remove ReadVirtDomains from vrcptcheck-real, it's in fd-common now


* Fri Feb 24 2006 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-dev
- Bugfix in vrcptcheck, unistd.h was not included
  (didn't manifest until FC4 ?)
- Tested with MySQL 5.x; not using BIT fields
- Prepare vrecordmail/vprocessmail for new schema - splitting the queue
  and storage functions into two different tables
- New CreateDBH function in fd-common.pl, can specify queue DB separate
  from vpopmail database (fd.mysql)
- Add 'userid' field to vpopmail database as auto_incremented INT
  Can be used for vpopmail, sessions, or other data relating to a user
- Store actual RCPT TO in queue rcvd_to field instead of the funky
  qmail/vpopmail-rewritten one (domain.com-user@domain.com)


* Wed Dec 14 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.7.2
- Mod vrcptcheck to output info on only one line during logging
- Minor change to default over-quota message in /etc/vpopmail/
- Multilog max log size is 16MB, not 20MB


* Tue Nov 29 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.7.1
- Bugfixes in blah-b-@domain.com handling in vrcptcheck, reloading of 
  virtUserFile due to typo
- Bugfix in vprocessmail, ensure proc_id is removed when backing out
  due to error, allows another process to attempt later.
- Cleanups in vrecordmail


* Wed Nov 23 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.7
- Allow vrcptcheck to run setuid via a C wrapper
- Bugfixes to vprocessmail, vrecordmail
- Create proper index for proc_lock column
- Run CPAN for Mail::RFC822::Address in post-install
- Add vuserdir for getting vpopmail users' home dirs for DSPAM


* Mon Nov 21 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.6
- Split into three separate packages, for clarity and better Requires tags
- SpamAssassin removed as a Require for finaldelivery, to allow
  better use of CPAN-retrieved updates
- Tweaks to the scriptlets
- Build for MySQL 5


* Wed Nov 16 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.5
- Add dspam-parse.sh via vprocessmail, not a Req since dspam uses the vpopmail user
- Open permissions on /etc/vpopmail/vpopmail.mysql to allow vrcptcheck to run


* Fri Oct 21 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.4
- Test build, not for public release
- Add creation of fd_settings table


* Fri Oct 21 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.3
- Test build, not for public release
- Changes to fd-additions.sql and vprocessmail to add more userprefs into
  the vpopmail DB


* Wed Sep 28 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.13-0.2
- Updated to 5.4.13
- New fd_mail_queue schema, SQL-based preferences
- Major updates to vrecordmail/vprocessmail
- Add vrcptcheck, vusersize
- Add enable-ip-alias-domains

* Mon Apr 11 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.10-1
- Updated to 5.4.10

* Mon Feb 06 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.9-2
- Performance improvements to vrecordmail and vprocessmail
- New fd_mail_record DB schema...

* Mon Jan 03 2005 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.9-1
- Update to 5.4.9
- Remove artificial perl Provides entries (placed in a shell package)

* Mon Dec 20 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.8-3
- Typo in fd-common.pl -> raw text log to /var/log/vpopmail/vprocessmail.log
- Add proctitle reporting to vrecordmail

* Tue Dec 14 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.8-2
- Fixes in vprocessmail for SA 3.0 compatibility

* Tue Dec 14 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.8-1
- Update to 5.4.8

* Tue Oct 5 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.7-1
- Update to 5.4.7

* Fri Sep 3 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.6-2
- Combine patches achieving the same goal together
- Move .msg files from domaindir to /etc/vpopmail
- Provide a default vpopmail password
- Create/delete an example domain to prime the vpopmail DB
- Add vmsginfo and vmsgreset scripts
- ClamAV version bug in fd-vprocessmail
- vdeldomain-real replacement script was left out of package
- More robust pre and post scripts

* Wed Jul 21 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.6-1
- Update to 5.4.6
- Moving a lot of hacks to simple patches to configure.in and makefile.in
- Lots of files renames

* Tue Jun 29 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.5-1
- Update to 5.4.5
- Remove symlinks in /var/vpopmail (unneeded)
- Minor cleanup

* Wed May 12 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.3-4
- Minor cleanup to prepare for FC2

* Mon Apr 12 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.3-3
- Tempfail on vrecordmail error instead of permfail
- Add show_vprocmail_queue script
- Add supervise entry for fd-vprocessmail
- Add /dev/shm, ripmime, and clamav requirement
- Disable MySQL logging

* Thu Apr 1 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.3-2
- Lots of final delivery fixes, fd-vprocessmail now works
- Added clamav and ripmime requirement

* Thu Mar 11 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.3-1
- Add vchkpassd program; poppassd daemon run via xinetd
- Updated to 5.4.3

* Fri Mar 5 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.2-0.8
- Valias fixes

* Thu Mar 4 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.2-0.7
- Turn domain quotas off to ease transitions from sendmail systems!
- Try to determine default domain name intelligently
- MySQL creation fixes

* Sun Feb 29 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.2-0.6
- Patch vpopmail.h to remove char *crypt line for vpopmail.pm
- More fd-vprocessmail updates

* Fri Feb 27 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.2-0.1
- Updated to 5.4.2
- Post install script MySQL changes
- More fd-vprocessmail updates

* Fri Feb 13 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.1-0.6
- Added creation of /var/log/qmail/vpopmail-fd
- fd-vprocessmail updates

* Wed Feb 11 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.1-0.5
- Updated to 5.4.1

* Tue Feb 3 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.0-0.3
- Modifed to look at /usr/sbin for qmail binaries.
- Change permissions on /usr/sbin/vchkpw for use with courier-imap

* Mon Feb 2 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.4.0-0.1
- Updated to Vpopmail 5.4.0 (stable)

* Thu Jan 22 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.3.30-2
- Build on Fedora Core 1

* Thu Jan 15 2004 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.3.30-1.5
- Fix mysql install post-script

* Tue Dec 16 2003 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.3.30-1
- Add "final delivery" concept, and fd-vrecordmail, fd-vdelivermail, fd-vprocessmail
- Move most binaries to /usr/sbin, except put vchangepw in /usr/bin
- Add symlinks for vuserinfo and vdelivermail in /usr/bin
- Move domains directory to /var/vpopmail/domains
- Add final delivery mysql table and additions to vpopmail table

* Wed Dec 10 2003 Japheth Cleaver <cleaver@rohan.sdsu.edu> 5.3.30-0
- New spec file
- Vpopmail home dir is /etc/vpopmail
- Add vlistemails script
- Move SMTP files to /var/vpopmail/open.smtp...
- Create dir for /usr/include/vpopmail and place files there
- Move libvpopmail.a to /usr/lib
- Try to determine if mysql is installed and, if so, create a vpopmail DB
